# -*- coding: utf-8 -*-
import json
import socket
import string
import random
from urllib import parse
from http.server import BaseHTTPRequestHandler,HTTPServer

SUPERNODE_HOST = "127.0.0.1"
SUPERNODE_MGT_PORT = 5645
HTTP_PORT = 58888
METHODS = ['supernodes','edges','communities','reload_communities','timestamps','packetstats','verbose']

def randomStr(digits=4):
    ran_str = ''.join(random.sample(string.ascii_letters + string.digits, digits))
    return ran_str

def sendData(data,tag):
    client = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)    
    response = client.sendto((data).encode(),(SUPERNODE_HOST.encode(),SUPERNODE_MGT_PORT))
    result = list()
    while True:
        data = client.recvfrom(2048)
        try:
            data = data[0].decode('gbk')
        except:
            data = data[0]
        data = json.loads(data)
        if data['_tag'] != tag:
            break
        if data['_type'] == 'end':
            break
        if data['_type'] == 'begin':
            continue
        result.append(data)
    return result

class N2N_API_Server(BaseHTTPRequestHandler):

    def log_message(self, format, *args):
        return

    def do_GET(self):
        method = "edges"
        #if "N2N" not in self.headers['Cookie']:
            #return
        try:
            if parse.urlparse(self.path).path == "/edges":
                query = parse.urlparse(self.path).query
                if query == "":
                    return
                if "&" in query:
                    community = query.split("&")[0]
                    tag = query.split("&")[1]
                    data="r "+tag+":0:bugxia "+method
                else:
                    community = query
                    tag = randomStr()
                    data="r "+tag+":0:bugxia "+method
                result = sendData(data,tag)
                data_ = list()
                for i in range(len(result)):
                    if result[i]["community"] == community:
                        data_.append(result[i])
            else:
                method = parse.urlparse(self.path).path.strip("/")
                if method not in METHODS:
                    return
                tag = randomStr()
                data="r "+randomStr()+":0:bugxia "+method
                result = sendData(data,tag)
                data_ = result
            self.send_response(200)
            self.send_header('Content-type', 'application/json')
            self.end_headers()
            self.wfile.write(json.dumps(data_).encode('utf8'))
            return

        except:
            return
try:
    server = HTTPServer(('', HTTP_PORT), N2N_API_Server)
    print ('Started N2N API HTTP server on port ' , HTTP_PORT)
    server.serve_forever()

except KeyboardInterrupt:
    print ('shutting down the N2N API HTTP server')
    server.socket.close()